
function getSelfFile() {
	var originalFile = document.location.toString();	// e.g. "file:///C:/projects/identikey/tid2.htm"
	return originalFile;
}

function getSelfPath() {
	var originalFile = document.location.toString();	// e.g. "file:///C:/projects/identikey/tid2.htm"
	var isForwardSlash = originalFile.lastIndexOf("/");
	if (isForwardSlash != -1) {
		originalFile = originalFile.substring(0, isForwardSlash+1);
	}
	return originalFile;
}

function saveLocalFileData(filename, datum) {

	var originalFile = document.location.toString();	// e.g. "file:///C:/projects/identikey/tid2.htm"
	var localFile = getLocalPath(originalFile);	// c:\\blah\\blah
	
	// now get the path
	var isForwardSlash = localFile.lastIndexOf("/");
	var isBackSlash = localFile.lastIndexOf("\\");
	if (isForwardSlash != -1) {
		localFile = localFile.substring(0, isForwardSlash+1);
	} else if (isBackSlash) {
		localFile = localFile.substring(0, isBackSlash+1);
	} else {
		// NOP - should never get here.
	}
	localFile += filename; 

	return saveFileData(localFile, datum);
}	

function saveFileData(localFile, datum) {
	var save;
	try {
		save = saveFile(localFile,datum);
	} catch (ex) {
		showException(ex);
	}
	if(save) {
		displayMessage(config.messages.mainSaved,"file://" + localFile);
		//store.setDirty(false);
	} else {
		alert(config.messages.mainFailed);
	}
	return save ? true : false;
}


function getLocalPath(origPath)
{
	var originalPath = convertUriToUTF8(origPath,config.options.txtFileSystemCharSet);
	// Remove any location or query part of the URL
	var argPos = originalPath.indexOf("?");
	if(argPos != -1)
		originalPath = originalPath.substr(0,argPos);
	var hashPos = originalPath.indexOf("#");
	if(hashPos != -1)
		originalPath = originalPath.substr(0,hashPos);
	// Convert file://localhost/ to file:///
	if(originalPath.indexOf("file://localhost/") == 0)
		originalPath = "file://" + originalPath.substr(16);
	// Convert to a native file format
	var localPath;
	if(originalPath.charAt(9) == ":") // pc local file
		localPath = unescape(originalPath.substr(8)).replace(new RegExp("/","g"),"\\");
	else if(originalPath.indexOf("file://///") == 0) // FireFox pc network file
		localPath = "\\\\" + unescape(originalPath.substr(10)).replace(new RegExp("/","g"),"\\");
	else if(originalPath.indexOf("file:///") == 0) // mac/unix local file
		localPath = unescape(originalPath.substr(7));
	else if(originalPath.indexOf("file:/") == 0) // mac/unix local file
		localPath = unescape(originalPath.substr(5));
	else // pc network file
		localPath = "\\\\" + unescape(originalPath.substr(7)).replace(new RegExp("/","g"),"\\");
	return localPath;
}

function getBackupPath(localPath,title,extension)
{
	var slash = "\\";
	var dirPathPos = localPath.lastIndexOf("\\");
	if(dirPathPos == -1) {
		dirPathPos = localPath.lastIndexOf("/");
		slash = "/";
	}
	var backupFolder = config.options.txtBackupFolder;
	if(!backupFolder || backupFolder == "")
		backupFolder = ".";
	var backupPath = localPath.substr(0,dirPathPos) + slash + backupFolder + localPath.substr(dirPathPos);
	backupPath = backupPath.substr(0,backupPath.lastIndexOf(".")) + ".";
	if(title)
		backupPath += title.replace(/[\\\/\*\?\":<> ]/g,"_") + ".";
	backupPath += (new Date()).convertToYYYYMMDDHHMMSSMMM() + "." + (extension || "html");
	return backupPath;
}
